//Datei: BIN2BCD.C
// Wandelt eine 16 Bit Binrzahl
// in 3 BCD Bytes=>6 Stellen
//
// Nach dem Beispiel von Microchip CD
// Benutzen, nur nicht drber nachdenken !
//
// Holger Klabunde
// 29.04.2001
// Compiler PICC Lite

#include "prozess.h"      /* Der verwendete Prozessor */
#include "protos.h"

//Input : 16 Bit Wert in B0=LSB,B1=MSB
//Output: 8 Bit Globale Register  R0,R1,R2
//        R0 = MSB, R2 = LSB
unsigned char B0,B1;
unsigned char R0,R1,R2;
unsigned char counter,temp;

void BinToBCD16()
{
 
#asm
        bcf _STATUS,0   // clear the carry bit
	movlw 0x10     //16 Bits bearbeiten
	movwf _counter  //Schleifenzhler
	clrf _R0        //R0,R1,R2,R3=0
	clrf _R1
	clrf _R2
loop16  rlf _B0     //Rotiere Bitweise in R2,R1,R0
	rlf _B1
	rlf _R2
	rlf _R1
	rlf _R0
	decfsz _counter  //Nchstes Bit
	goto adjDEC
	RETLW 0

adjDEC	movlw _R2        //Auch fr R2,R1,R0
	movwf _FSR
	call adjBCD
	movlw _R1       
	movwf _FSR
	call adjBCD
	movlw _R0
	movwf _FSR
	call adjBCD
	goto loop16     //Nchstes von den 16 Bits

	//Register 0 zeigt auf R3,R2,R1 oder R0
adjBCD  movlw 0x03     //Untere BCD-Stelle testen
	addwf 0,W      //0x03 addieren zu R0,R1,R2 oder R3
	movwf _temp     //zwischenspeichern fr Test Bit D3
	btfsc _temp,3   
	movwf 0        

	movlw 0x30     //Das gleiche mit der oberen BCD-Stelle
	addwf 0,W
	movwf _temp
	btfsc _temp,7   
	movwf 0        
	RETLW 0        // Ergebnis in R0,R1,R2,R3 zurckgeben
#endasm
}

//{Zeigt ein BCD-Byte auf der LCD-Anzeige }
//
void ShowBCD(unsigned char x)
{
 //ASCII Zahlen beginnen bei 0x30 => 0
 LCDWriteByte((x>>4)+0x30);  //High-Nibble
 LCDWriteByte((x&0x0F)+0x30);  //Low-Nibble
}

